{**********************************************************************
                PilotLogic Software House.
  
 Package pl_OnGuard.pkg
 This unit is part of CodeTyphon Studio (http://www.pilotlogic.com/)
***********************************************************************}

{$I ONGUARD.INC}


unit allonguardregister;


interface

procedure Register;

implementation

{$R allonguardregister.res}

uses
  Classes, Forms,
  qogabout0, ogconst, ognetwrk, ogproexe,
  onguard,
  qonguard2,
  qonguard3,
  qonguard5,
  qonguard6,
  qonguard7,
  ComponentEditors,
  PropEdits,
  TyphonPackageIntf,
  LResources;

type
  {component editor for TogCodeBase components}
  TOgCodeGenEditor = class({TDefaultEditor}TDefaultComponentEditor)
  public
    procedure ExecuteVerb(Index: integer); override;
    function GetVerb(Index: integer): string; override;
    function GetVerbCount: integer; override;
  end;


{*** TOgCodeGenEditor ***}

procedure TOgCodeGenEditor.ExecuteVerb(Index: integer);
begin
  if Index = 0 then
  begin
    with TCodeGenerateFrm.Create(Application) do
      try
        ShowHint := True;
        KeyFileName := OgKeyFile;
        if Component is TOgDateCode then
          CodeType := ctDate
        else if Component is TOgDaysCode then
          CodeType := ctDays
        else if Component is TOgNetCode then
          CodeType := ctNetwork
        else if Component is TOgRegistrationCode then
          CodeType := ctRegistration
        else if Component is TOgSerialNumberCode then
          CodeType := ctSerialNumber
        else if Component is TOgSpecialCode then
          CodeType := ctSpecial
        else if Component is TOgUsageCode then
          CodeType := ctUsage;
        ShowModal;
      finally
        Free;
      end;
  end
  else if Index = 1 then
  begin
    with TKeyMaintFrm.Create(Application) do
      try
        ShowHint := True;
        KeyFileName := 'ONGUARD.INI';
        KeyType := ktRandom;
        ShowModal;
      finally
        Free;
      end;
  end;
end;

function TOgCodeGenEditor.GetVerb(Index: integer): string;
begin
  case Index of
    0: Result := 'Generate Code';
    1: Result := 'Generate Key';
    else
      Result := '?';
  end;
end;

function TOgCodeGenEditor.GetVerbCount: integer;
begin
  Result := 2;
end;


procedure Register;
begin
  RegisterComponents('OnGuard', [TOgMakeKeys,
                                 TOgMakeCodes,
                                 TOgDateCode,
                                 TOgDaysCode,
                                 TOgNetCode,
                                 TOgRegistrationCode,
                                 TOgSerialNumberCode,
                                 TOgSpecialCode,
                                 TOgUsageCode,
                                 TOgProtectExe]);

  RegisterComponentEditor(TOgCodeBase, TOgCodeGenEditor);

  RegisterPropertyEditor( TypeInfo(string), TOgMakeKeys, 'KeyFileName', TOgFileNameProperty);
  RegisterPropertyEditor( TypeInfo(string), TOgMakeCodes, 'KeyFileName', TOgFileNameProperty);
  {  RegisterPropertyEditor( }{!!.09}
  {    TypeInfo(string), TOgCodeBase, 'Expires', TOgExpiresProperty);}
  RegisterPropertyEditor(  TypeInfo(string), TOgCodeBase, 'Code', TOgCodeProperty);
  RegisterPropertyEditor(  TypeInfo(string), TOgCodeBase, 'Modifier', TOgModifierProperty);
  RegisterPropertyEditor(  TypeInfo(string), TOgCodeBase, 'About', TOgAboutProperty);
  RegisterPropertyEditor(  TypeInfo(string), TOgProtectExe, 'About', TOgAboutProperty);
  RegisterPropertyEditor(  TypeInfo(string), TOgMakeCodes, 'About', TOgAboutProperty);
  RegisterPropertyEditor(  TypeInfo(string), TOgMakeKeys, 'About', TOgAboutProperty);
end;


end.
